/* Plugin generated by AMXX-Studio */
/*
*  AMX Mod X script
*
*	Clipon - Temporary noclip for TFC skills servers or any TFC server where
*	you want the players to spec with noclip without being able to interact.
*
*	by Lt Llama
*
*
*  WHAT IS THIS?
*  ====================
*	If you are used to play on skills servers and come to some odd jump,
*	you would prefer to see what is in front of you. Many times you don't have
*	the possibility and just have to do trial and error. Sometimes you can ask
*	an admin to give you noclip or tele you back so you can spec the jump.
*	With Clipon all players can noclip and not cheat.
*	When you say /clipon you have a time limited noclip to spec the jump.
*	When the time is up you get teleported back to the spot you started /clipon on
* 	or when you say /clipoff.
*	
*  WHAT YOU CANT DO DURING /CLIPON
*  ====================
*  - No killing of enemies. The damage will be mirrored.
*  - No touching of entities. 
*  - No pressing of buttons. If you press the Use button you will be killed. This is to prevent
*    from haxing on maps like conc_2v2 or manipulate other buttons.
*
*  USER COMMANDS
*  =============
* - say '/clipon' to noclip during a time which is time limited.
* - say '/clipoff' to teleport back to where you started to noclip.
*
*  CVARS
*  =============
*  cliptime <seconds> 	- The time the player is allowed to noclip. Default = 40 seconds.
*
*
*  ISSUES
*  =============
*  Stay away from corners and walls. You will get stuck. I know this can be fixed, and I will probably
*  do it. But for now it is like it is :).
*
*  VERSIONS
*  ========
*  0.9  	- First working version (2006-12-18)
*/

#include <amxmodx>
#include <engine>
#include <fun>
#include <tfcx>

#define PLUGIN "Clipon"
#define VERSION "0.9"
#define AUTHOR "Lt Llama"

new clipperOrigin[33][3]
new clipteam[33]
new clipclass[33]
new bool:isClipping[33]
new g_cliptime

public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	// Add your code here...
	register_clcmd("say /clipon","clipOn",0,"- gives noclip for amx_cliptime.") 
	register_clcmd("say /clipoff","clipOff",0,"- resets noclip and teleports you back") 
	g_cliptime = register_cvar("cliptime","40.0")  // Time before temp noclip turns off
}


// Clear the tasks and cvars attached to id's
public client_disconnect(id) {
	isClipping[id] = false
}

// Give player noclip when he says /clipon for cliptime <seconds>
public clipOn(id){
	if(is_user_alive(id)) {
		if (isClipping[id]) {
			client_print(id,print_chat, "Can't use while noclipping")
		} else {
			// Check if the use is standing still when using /clipon.
			// We dont want mid air hax.
			new Float:movement[3]
			get_user_velocity(id,movement)
			if(movement[0]==0.0 && movement[1]==0.0) {
				clipteam[id] = get_user_team(id)
				clipclass[id] = get_user_class(id)
				// Disable engineers using /clipon
				if (clipclass[id] == 9) {
					client_print(id,print_chat, "Engineers are not allowed to use /clipon")	
				} else {
					isClipping[id] = true
					client_print(id,print_chat, "Noclip resets in %i seconds. /clipoff gets you back faster.",floatround(get_pcvar_float(g_cliptime)))
					get_user_origin(id,clipperOrigin[id],0)
					set_user_noclip(id,1)
					set_task(get_pcvar_float(g_cliptime),"clipOff",id)
					entity_set_int(id,EV_INT_solid,SOLID_NOT)
					return PLUGIN_CONTINUE
				}
				} else {
				client_print(id,print_chat, "Dont move when using /clipon")
				return PLUGIN_HANDLED
			}
		}
	}
	return PLUGIN_CONTINUE
}

// Resets a noclipping player and teleports him back to the place he started
// /clipon at.
public clipOff(id){
	new classcheck,teamcheck
	teamcheck = get_user_team(id)
	classcheck = get_user_class(id)
	
	if (isClipping[id] == true) {
		// Check if player switched team or class. Is so = invert damage.
		if(teamcheck != clipteam[id] || classcheck != clipclass[id]) {
			new name[32] ; get_user_name(id,name,31)
			if(is_user_alive(id)) {
				client_print(0,print_chat, "%s tried to hax! %s is now dead!",name,name)
				user_kill(id) 
			}
			isClipping[id] = false
			} else if (isClipping[id]) {
			set_user_origin(id,clipperOrigin[id])
			client_print(id,print_chat, "You have been teleported back to the spot you started noclip on.")
			isClipping[id] = false
			set_user_noclip(id,0)
			if(is_user_alive(id))
				entity_set_int(id,EV_INT_solid,SOLID_BBOX)
			return PLUGIN_CONTINUE
		}
	}
	return PLUGIN_CONTINUE
}

// If a player is attacking another player during noclip the damage is mirrored.
// Inspiration by EKS Mirror Damage plugin http://forums.alliedmods.net/showthread.php?p=77112
public client_damage (attacker, victim, damage, wpnindex, hitplace, TA ) {
	if(is_user_connected(attacker) && is_user_connected(victim) && is_user_alive(victim)) {
		if(!TA && victim != attacker) {
			if(isClipping[attacker]) {
				set_user_health(victim,(get_user_health(victim)+damage))
				new bumHp = get_user_health(attacker) - damage
				new name[32] ; get_user_name(victim,name,31)
				client_print(attacker,print_chat, "You attacked %s when noclipping and lost %d hp",name,damage)
				if(bumHp > 0) {
					set_user_health(attacker,(get_user_health(attacker)-damage))
					} else {
					if (task_exists(attacker)) remove_task(attacker)
					clipOff(attacker)
					user_kill(attacker)
				}
			}
		}
	}
}

// Checks if a player is pressing the USE key when he is using /clipon
public client_PreThink ( id ) {
	if(get_user_button(id) & IN_USE) { 
		if (isClipping[id]) {
			new name[32] ; get_user_name(id,name,31)
			client_print(0,print_chat, "%s tried the BUTTON HAX! R.I.P %s",name,name)
			user_kill(id) 
			isClipping[id] = false
		}
	}
	return PLUGIN_CONTINUE
}

// Gets the player class
stock get_user_class(id) {
	new playerclass = entity_get_int(id, EV_INT_playerclass)
	return playerclass
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1053\\ f0\\ fs16 \n\\ par }
*/
